/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_CALECOMP                                                */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao do calendrio de compra              */
/*                                                                            */
/* Criao:                                                                   */
/* 21/07/2000 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/* Manutenes TRG :                                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CALECOMP'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_CALECOMP
  GO

CREATE TRIGGER DTULTATU_CALECOMP
ON CALECOMP
FOR INSERT, UPDATE
AS
BEGIN
   UPDATE CALECOMP
   SET DTULTATUCALE = GETDATE()
   FROM INSERTED
   WHERE ISNULL(CALECOMP.CDFILIAL,0)   = ISNULL(INSERTED.CDFILIAL,0)   AND
         ISNULL(CALECOMP.CDPERIENTR,0) = ISNULL(INSERTED.CDPERIENTR,0) AND
         ISNULL(CALECOMP.DTENTREGA,0) = ISNULL(INSERTED.DTENTREGA,0);
END;
GO
