function ger01900_relatoriocustomizavelproduto_controller(ZhFilterPreferences, ScreenService, General, templateManager, localStorageEngine) {

	this.enableDisableData = function(widget) {
		var PARAM = widget.currentRow.PARAM;

		if(PARAM == 'D'){
			widget.getField('NRDIAS').readOnly = false;
			widget.getField('DATAINI').readOnly = true;
			widget.getField('DATAFIN').readOnly = true;
			
			widget.getField('NRDIAS').validations = {"min": {"limit": 1}, "max": {"value": 999}};
			widget.getField('DATAINI').validations = {};
			widget.getField('DATAFIN').validations = {};
		}else if(PARAM == 'P'){
			widget.getField('NRDIAS').readOnly = true;
			widget.getField('DATAINI').readOnly = false;
			widget.getField('DATAFIN').readOnly = false;
			
			widget.getField('NRDIAS').validations = {};
			widget.getField('DATAINI').validations = {"required": true};
			widget.getField('DATAFIN').validations = {"required": true};
		}
		
		widget.getField('NRDIAS').reload();
		widget.getField('DATAINI').reload();
		widget.getField('DATAFIN').reload();
	
	};

    this.openFilter = function(widget){
        var rowsToSet = {};
        
        var levels = General.getLevelByMask("GER_CDPICTPROD", 1);
		var nivelField = widget.getField("NIVEL");
		var data = [];
		levels.forEach(function(level) {
		    data.push({value: level.nivel, description: level.nivel});
		});
		
		nivelField.dataSource.data = data;
            rowsToSet.TIPODEORDENACAO = 'CODIGO';
            rowsToSet.NIVEL = String(data.length);
            rowsToSet.TPLISTPROD = '2';
            
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function(){
                // templateManager.container.getActiveWidget().getAction('close').isVisible = false;
                // this.changeFilial(widget);
            }.bind(this));
    };
    
    this.habilitaNvOrdenacao = function(args){
        var widget = args.owner.field.widget;
        if(widget.getField('TIPODEORDENACAO').value() == 'NOME'){
            templateManager.container.getWidget('produtos').order = ["NMPRODUTO"];
            widget.getField('NIVEL').readOnly = false;
            widget.getField('TPLISTPROD').readOnly = true;
            widget.getField('TPLISTPROD').value(String(2));
            
            templateManager.container.getWidget('produtos').dataSource.name = "cadEst#/crud/customizavel_produto_completa_alfabetica";
            templateManager.container.getWidget('produtos').floatingControl.xlsAction.dataSourceName = "customizavel_produto_completa_alfabetica";
        }else{
            templateManager.container.getWidget('produtos').order = ["CDARVPROD"];
            var tam = widget.getField('NIVEL').dataSource.data.length;
            widget.getField('NIVEL').readOnly = true;
            widget.getField('NIVEL').value(String(tam));
            widget.getField('TPLISTPROD').readOnly = false;
            
            templateManager.container.getWidget('produtos').dataSource.name = "cadEst#/crud/customizavel_produto_completa";
            templateManager.container.getWidget('produtos').floatingControl.xlsAction.dataSourceName = "customizavel_produto_completa";
        }
    };
	
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
	
	//Parâmetros Filtro da Widget
    this.changeFilter = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        var filtro = [];
        
        var mascara = 20 - filterRow.CDARVPRODFIN.length;
		var produtoFinal = filterRow.CDARVPRODFIN + 'z'.repeat(mascara).substring(0, mascara);
		
        filtro = [
            {
                "name":"P_PRODINI",
                "operator":"=",
                "value": filterRow.CDARVPRODINI ? filterRow.CDARVPRODINI : null
            },
            {
                "name":"P_PRODFIM",
                "operator":"=",
                "value": produtoFinal
            },
            {
                "name": "P_NIVEL",
                "operator": "=",
                "value": filterRow.NIVEL
            },
            {
                "name": "P_TPLISTPROD",
                "operator": "=",
                "value": filterRow.TPLISTPROD
            }
        ];
        
        widget.dataSourceFilter = filtro;
        widget.reload();
        
    };
    
    this.changeFilterLancEstoq = function(args){
        var cdfilial = args.owner.field.widget.currentRow.CDFILIAL;   
        var dtlancestq = args.owner.field.widget.currentRow.DTLANCESTQ;   
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[0].value = cdfilial;
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[1].value = dtlancestq;
        if(dtlancestq != ""){
            args.owner.field.widget.getField('NRLANCESTQ').reload();
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/crud/itlanctoest_produto";
        }else{
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/produto_posestatu_paramfilial";
        }
    };
    
    this.changeFilterLancEstoqByFilial = function(args){
        var cdfilial = args.owner.field.widget.currentRow.CDFILIAL;   
        var dtlancestq = args.owner.field.widget.currentRow.DTLANCESTQ;   
        
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[0].value = cdfilial;
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[1].value = dtlancestq;
        args.owner.field.widget.currentRow.NRLANCESTQ = "";
        if(dtlancestq != ""){
            args.owner.field.widget.getField('NRLANCESTQ').reload();
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/crud/itlanctoest_produto";
        }else{
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/produto_posestatu_paramfilial";
        }
    };

}

Configuration(function(ContextRegister) {
	ContextRegister.register('ger01900_relatoriocustomizavelproduto_controller', ger01900_relatoriocustomizavelproduto_controller);
});
